import { UnionTypeDefinitionNode } from 'graphql/language/ast';
import { ParsedConfig, BaseVisitor } from 'graphql-codegen-visitor-plugin-common';
import { TypeScriptMongoPluginConfig } from './index';
import { GraphQLSchema, ObjectTypeDefinitionNode, InterfaceTypeDefinitionNode } from 'graphql';
export interface TypeScriptMongoPluginParsedConfig extends ParsedConfig {
    dbTypeSuffix: string;
    dbInterfaceSuffix: string;
    objectIdType: string;
    idFieldName: string;
    enumsAsString: boolean;
    avoidOptionals: boolean;
}
export declare class TsMongoVisitor extends BaseVisitor<TypeScriptMongoPluginConfig, TypeScriptMongoPluginParsedConfig> {
    private _schema;
    private _variablesTransformer;
    constructor(_schema: GraphQLSchema, pluginConfig: TypeScriptMongoPluginConfig);
    private _resolveDirectiveValue;
    private _getDirectiveArgValue;
    private _getDirectiveFromAstNode;
    private _buildInterfaces;
    private _handleIdField;
    private _handleLinkField;
    private _handleColumnField;
    private _handleEmbeddedField;
    private _buildFieldsTree;
    private _addAdditionalFields;
    InterfaceTypeDefinition(node: InterfaceTypeDefinitionNode): string;
    UnionTypeDefinition(node: UnionTypeDefinitionNode): string;
    ObjectTypeDefinition(node: ObjectTypeDefinitionNode): string;
}
